var nameSort = 0; // declare variable
var distanceSort = 0; // declare variable
var elevationSort = 0; // declare variable
var difficultySort = 0; // declare variable
var popularitySort = 0; // declare variable
var ratingSort = 0; // declare variable
// 0 means unsorted, 1 means descending, 2 means ascending
var trails = []; // declare Array
var i; // for loops

trails[0] = {
  name: "Coal Mine Trail",
  loc: "./coalmine.htm",
  distance: 5.41,
  elevate: 297,
  difficulty: 2, 
  popularity: 2,
  rating: 7
};

trails[1] = {
  name: "Heart Creek Trail",
  loc: "./heartcreek.htm", 
  distance: 4.58,
  elevate: 340,
  difficulty: 1, 
  popularity: 5,
  rating: 3
};

trails[2] = {
  name: "Lower Bertha Falls",
  loc: "./lowerberthafalls.htm", 
  distance: 5.63,
  elevate: 209,
  difficulty: 2, 
  popularity: 3,
  rating: 8
};

trails[3] = {
  name: "Ribbon Falls",
  loc: "./ribbonfalls.htm", 
  distance: 19.78,
  elevate: 723,
  difficulty: 3, 
  popularity: 3,
  rating: 10
};

trails[4] = {
  name: "Troll Falls",
  loc: "./trollfalls.htm", 
  distance: 3.58,
  elevate: 147,
  difficulty: 1, 
  popularity: 5,
  rating: 6
};

trails[5] = {
  name: "Blackshale Suspension Bridge via Black Prince",
  loc: "./blackshalesuspension.htm", 
  distance: 6.24,
  elevate: 342,
  difficulty: 2, 
  popularity: 3,
  rating: 4
};

// sort by name
function sortName() {
  distanceSort = 0;
  elevationSort = 0;
  difficultySort = 0;
  popularitySort = 0;
  ratingSort = 0;
  // reset these to status unsorted
  if (nameSort == 0) {
	// sort descending
    trails.sort(function(a, b){return a.name.localeCompare(b.name)});
	nameSort = 1;
  }
  else if (nameSort == 1) {
	// currently sorted descending, sort ascending
    trails.sort(function(a, b){return a.name.localeCompare(b.name)});
    trails.reverse();
	nameSort = 2;
  }
  else	{
	// currented sorted ascending, sort descending
    trails.sort(function(a, b){return a.name.localeCompare(b.name)});
	nameSort = 1;	  
  }
  renderTable();
}

// sort by distance
function sortDistance()	{
  nameSort = 0;
  elevationSort = 0;
  difficultySort = 0;
  popularitySort = 0;
  ratingSort = 0;
  // reset these to status unsorted
  if (distanceSort == 0) {
	// sort descending
    trails.sort(function(a, b){return b.distance - a.distance});
	distanceSort = 1;
  }
  else if (distanceSort == 1) {
	// currently sorted descending, sort ascending
    trails.sort(function(a, b){return b.distance - a.distance});
    trails.reverse();
	distanceSort = 2;
  }
  else	{
	// currented sorted ascending, sort descending
    trails.sort(function(a, b){return b.distance - a.distance});
	distanceSort = 1;	  
  }
  renderTable();
}

// sort by elevation
function sortElevate()	{
  nameSort = 0;
  distanceSort = 0;
  difficultySort = 0;
  popularitySort = 0;
  ratingSort = 0;
  // reset these to status unsorted
  if (elevationSort == 0) {
	// sort descending
    trails.sort(function(a, b){return b.elevate - a.elevate});
	elevationSort = 1;
  }
  else if (elevationSort == 1) {
	// currently sorted descending, sort ascending
    trails.sort(function(a, b){return b.elevate - a.elevate});
    trails.reverse();
	elevationSort = 2;
  }
  else	{
	// currented sorted ascending, sort descending
    trails.sort(function(a, b){return b.elevate - a.elevate});
	elevationSort = 1;	  
  }
  renderTable();
}

// sort by difficulty
function sortDifficulty()	{
  nameSort = 0;
  distanceSort = 0;
  elevationSort = 0;
  popularitySort = 0;
  ratingSort = 0;
  // reset these to status unsorted
  if (difficultySort == 0) {
	// sort descending
    trails.sort(function(a, b){return b.difficulty - a.difficulty});
	difficultySort = 1;
  }
  else if (difficultySort == 1) {
	// currently sorted descending, sort ascending
    trails.sort(function(a, b){return b.difficulty - a.difficulty});
    trails.reverse();
	difficultySort = 2;
  }
  else	{
	// currented sorted ascending, sort descending
    trails.sort(function(a, b){return b.difficulty - a.difficulty});
	difficultySort = 1;	  
  }
  renderTable();
}

// sort by popularity
function sortPopularity()	{
  nameSort = 0;
  distanceSort = 0;
  elevationSort = 0;
  difficultySort = 0;
  ratingSort = 0;
  // reset these to status unsorted
  if (popularitySort == 0) {
	// sort descending
    trails.sort(function(a, b){return b.popularity - a.popularity});
	popularitySort = 1;
  }
  else if (popularitySort == 1) {
	// currently sorted descending, sort ascending
    trails.sort(function(a, b){return b.popularity - a.popularity});
    trails.reverse();
	popularitySort = 2;
  }
  else	{
	// currented sorted ascending, sort descending
    trails.sort(function(a, b){return b.popularity - a.popularity});
	popularitySort = 1;	  
  }
  renderTable();
}

// sort by rating
function sortRating()	{
  nameSort = 0;
  distanceSort = 0;
  elevationSort = 0;
  difficultySort = 0;
  popularitySort = 0;
  // reset these to status unsorted
  if (ratingSort == 0) {
	// sort descending
    trails.sort(function(a, b){return b.rating - a.rating});
	ratingSort = 1;
  }
  else if (ratingSort == 1) {
	// currently sorted descending, sort ascending
    trails.sort(function(a, b){return b.rating - a.rating});
    trails.reverse();
	ratingSort = 2;
  }
  else	{
	// currented sorted ascending, sort descending
    trails.sort(function(a, b){return b.rating - a.rating});
	ratingSort = 1;	  
  }
  renderTable();
}

// Convert the number to a string
function difficultyOutputString(n)	{
  switch (n) {
    case 1:
	  return "None";
    case 2:
	  return "Easier";
    case 3:
	  return "Moderate";
    case 4:
	  return "Leg Burner";
    default:
	  return "Hard";
  }
}

// Convert the number to a string
function popularOutputString(n) {
  switch (n) {
    case 1:
	  return "None";
    case 2:
	  return "Low";
    case 3:
	  return "Moderate";
    case 4:
	  return "Busy";
    default:
	  return "Too Busy";
  }	  
}

/* Print the new array of trails by working through the array
and placing them in the table based on IDs of each table TD */
function renderTable() {
  for (i = 0; i < trails.length; i++)	{
	document.getElementById("name" + i + "").innerHTML = trails[i].name;
	document.getElementById("name" + i + "").href = trails[i].loc;
	document.getElementById("dis" + i + "").innerHTML = trails[i].distance;
	document.getElementById("elv" + i + "").innerHTML = trails[i].elevate;
	document.getElementById("dif" + i + "").innerHTML = difficultyOutputString(trails[i].difficulty);
	document.getElementById("pop"	+ i + "").innerHTML = popularOutputString(trails[i].popularity);
	document.getElementById("rat" + i + "").innerHTML = trails[i].rating;
  }
}