
var images = []; // Declare Array
var x; //constant to control array object
x = 0; //initialize to 0

// now declare each object for the array

/*
thumb = low res version of an images
full = high res version of an images
description = used for alt text and description
*/

images[0] = {
  thumb: "./images/heartcreek/image1t.jpg",
  full: "./images/heartcreek/image1.jpg",
  description: "View from up a small hill"
};

images[1] = {
  thumb: "./images/heartcreek/image2t.jpg",
  full: "./images/heartcreek/image2.jpg",
  description: "After the fork, some minor rock"
};

images[2] = {
  thumb: "./images/heartcreek/image3t.jpg",
  full: "./images/heartcreek/image3.jpg",
  description: "Side of a mountain"
};

images[3] = {
  thumb: "./images/heartcreek/image4t.jpg",
  full: "./images/heartcreek/image4.jpg",
  description: "Another standard view of the trail"
};

images[4] = {
  thumb: "./images/heartcreek/image5t.jpg",
  full: "./images/heartcreek/image5.jpg",
  description: "Closeup of a flower"
};

images[5] = {
  thumb: "./images/heartcreek/image6t.jpg",
  full: "./images/heartcreek/image6.jpg",
  description: "Not much variety to be seen"
};

/* This function reduces the value of x
by 1, reducing the array selected. But if x 
is currently the first array object already
then it goes to the last array object. It then replaces
all items associated with the picture with the last 
object's parts
*/
function lastImage()	{
  if (x == 0)
    x = 5;
  else
    x--;
  document.getElementById('pictureFull').href = images[x].full;
  document.getElementById('pictureThumb').src = images[x].thumb;
  document.getElementById('pictureThumb').alt = images[x].description;
  document.getElementById('pictureDesc').innerHTML = images[x].description;
}

/* This function increases the value of x
by 1, increasing the array selected. But if x 
is currently the first array object already,
then it goes to the last array object. It then replaces
all items associated with the picture with the next 
object's parts
*/
function nextImage()	{
  if (x == 5)
    x = 0;
  else
    x++;
  document.getElementById('pictureFull').href = images[x].full;
  document.getElementById('pictureThumb').src = images[x].thumb;
  document.getElementById('pictureThumb').alt = images[x].description;
  document.getElementById('pictureDesc').innerHTML = images[x].description;
}

// run the script of changing the image every 3 seconds
setInterval(nextImage,3000);